//=============================================================================
//
//  CLASS LightBuffer - IMPLEMENTATION
//
//=============================================================================

#define RAYTRACER_LIGHTBUFFER_CPP


//== INCLUDES =================================================================
#include "LightBuffer.h"
#include "SurfaceList.h"

//== IMPLEMENTATION ========================================================== 

LightBuffer::LightBuffer( const SurfaceList *scene )
{
    /*
		Implementieren Sie:
		
		Aufbau des LightBuffers zur Beschleunigung der Lichtquelle-Szenen-Schnittberechnung
	*/
	
	//Beispielcode zum traversieren aller Objekte in der Szene
    m_scene = scene;
    SurfaceContainerType::const_iterator    it = m_scene->m_surfaceContainer.begin();
    SurfaceContainerType::const_iterator    it_end = m_scene->m_surfaceContainer.end();
    for( ; it != it_end; ++it )
    {
         //Jedes Objekt in der Szene besitzt die Funktion getAABB()
         //Das sollte nuetzlich sein zum Einfuegen der Objekte in
         //die Beschleunigungsdatenstruktur
         AABBox bbox = (*it)->getAABB();
    }
}

// Destructor
LightBuffer::~LightBuffer()
{ 
    /*
		Implementieren Sie:
		
		Aufrumen beim Lschen eines Light-Buffers
	*/
}

//-----------------------------------------------------------------------------

bool 
LightBuffer::intersect(const Ray&     clRay, 
	   					const double      t0, 
						const double      t1, 
						TracingContext&    tContext ) const
{
  /*
		Implementieren Sie:
		
		Schnittberechnung mit der Szene mit Hilfe eines Lightbuffers
	*/
	return false;
}